VERSION 5.00
Begin VB.UserControl oAmpel 
   BackColor       =   &H00404040&
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   PropertyPages   =   "oAmpel.ctx":0000
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ToolboxBitmap   =   "oAmpel.ctx":0014
   Begin VB.Timer tmrRedPhase 
      Left            =   1080
      Top             =   120
   End
   Begin VB.Timer tmrYellowPhase 
      Left            =   600
      Top             =   120
   End
   Begin VB.Timer tmrGreenPhase 
      Left            =   120
      Top             =   120
   End
   Begin VB.Timer tmrRedYellowPhase 
      Left            =   1560
      Top             =   120
   End
   Begin VB.Timer tmrFlash 
      Left            =   2760
      Top             =   120
   End
End
Attribute VB_Name = "oAmpel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

Private Declare Sub InitCommonControls Lib "comctl32" ()

Private Declare Function DrawFocusRect Lib "user32" (ByVal hDC As Long, lpRect As RECT) As Long

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" _
(ByVal hwnd As Long, ByVal nIndex As Long) As Long

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
(ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Declare Function SetWindowPos Lib "user32" _
(ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, _
ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Declare Function GetSysColor Lib "USER32.DLL" (ByVal nIndex As Long) As Long

Private Const SWP_FRAMECHANGED = &H20
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOOWNERZORDER = &H200
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOZORDER = &H4

Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public Enum enumOrientation
     Vertikal
     Horizontal
End Enum

Public Enum eGreenOrientation
    Standard = 0
    Rechts = 1
    Oben = 2
    Links = 3
End Enum

Public Enum eOrientationArrowhead
    [Fahrtrichtung geradeaus] = 0
    [Fahrtrichtung rechts] = 1
    [Fahrtrichtung links] = 2
    Fugnger = 3
End Enum

Public Enum eGradientOrientation
    vHorizontal = 0
    vVertikal = 1
End Enum

Public Enum eBorderStyle
    [Kein] = 0
    [Fest Einfach] = 1
    [erhht] = 2
    [Rahmen] = 3
End Enum

Public Enum eMousePointerConstants
    Voreinstellung = 0
    Pfeil = 1
    Kreuz = 2
    I_Cursor = 3
    Symbol = 4
    Grennderung = 5
    Grennderung_NO_SW = 6
    Grennderung_N_S = 7
    Grennderung_NW_SO = 8
    Grennderung_W_O = 9
    Aufwrtspfeil = 10
    Sanduhr = 11
    Nicht_ablegen = 12
    Pfeil_und_Sanduhr = 13
    Pfeil_und_Fragezeichen = 14
    Grennderung_alle = 15
    Benutzerdefiniert = 99
End Enum


Private Const FillColorGreen = vbGreen
Private Const FillColorYellow = vbYellow
Private Const FillColorRed = vbRed

Private Const Innenabstand = 0.9
Dim hasFocus As Boolean
Private XPos, YPos, Radius, Rand

'Standard-Eigenschaftswerte:
Const m_def_DrawWidth = 1
Const m_def_ShowFocusRect = True
Const m_def_ShowArrows = False
Const m_def_OrientationArrowhead = 0
Const m_def_IntervalGreenPhase = 0
Const m_def_IntervalYellowPhase = 0
Const m_def_IntervalRedPhase = 0
Const m_def_IntervalRedYellowPhase = 0
Const m_def_GreenOrientation = 0
Const m_def_GradientOrientation = 0
Const m_def_BackColor = &H404040
Const m_def_BackColor2 = vbWhite
Const m_def_Gradient = False
Const m_def_AutomaticMode = False
Const m_def_FlashMode = False
Const m_def_Enabled = True
Const m_def_FillColor = &H808080
Const m_def_BorderStyle = 0
Const m_def_Orientation = Vertikal
Const m_def_ModeRed = False
Const m_def_ModeGreen = True
Const m_def_ModeYellow = False
'Eigenschaftsvariablen:
Dim m_DrawWidth As Integer
Dim m_ShowFocusRect As Boolean
Dim m_ShowArrows As Boolean
Dim m_OrientationArrowhead As eOrientationArrowhead
Dim m_IntervalGreenPhase As Long
Dim m_IntervalYellowPhase As Long
Dim m_IntervalRedPhase As Long
Dim m_IntervalRedYellowPhase As Long
Dim m_GreenOrientation As eGreenOrientation
Dim m_GradientOrientation As eGradientOrientation
Dim m_BackColor As OLE_COLOR
Dim m_BackColor2 As OLE_COLOR
Dim m_Gradient As Boolean
Dim m_AutomaticMode As Boolean
Dim m_FlashMode As Boolean
Dim m_Enabled As Boolean
Dim m_FillColor As OLE_COLOR
Dim m_BorderStyle As eBorderStyle
Dim m_Orientation As enumOrientation
Dim m_ModeRed As Boolean
Dim m_ModeGreen As Boolean
Dim m_ModeYellow As Boolean
'Ereignisdeklarationen:
Event ByActivate()
Event ByFlash()
Event ByGreen()
Event ByYellow()
Event ByDeActivate()
Event ByRed()
Event ByRedYellow()
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Event Resize() 'MappingInfo=UserControl,UserControl,-1,Resize

Private Sub BorderStyleRaised(ByVal hwnd As Long, Optional ByVal Undo As Boolean)
    Dim nStyle As Long
    
    Const GWL_STYLE = (-16)
    Const WS_DLGFRAME = &H400000
    
    nStyle = GetWindowLong(hwnd, GWL_STYLE)
    If Undo Then
        nStyle = nStyle And Not WS_DLGFRAME
    Else
        nStyle = nStyle Or WS_DLGFRAME
    End If
    SetWindowLong hwnd, GWL_STYLE, nStyle
    SetWindowPos hwnd, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER Or SWP_NOZORDER Or SWP_FRAMECHANGED
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,False
Public Property Get ModeRed() As Boolean
Attribute ModeRed.VB_Description = "gibt den Aktivierungs-Modus zurck oder legt ihn fest"
    ModeRed = m_ModeRed
End Property

Public Property Let ModeRed(ByVal New_ModeRed As Boolean)
On Error GoTo Fehlerbehandlung

If Ambient.UserMode = False Then
    m_ModeRed = New_ModeRed
    Call AmpelAnzeigen
    PropertyChanged "ModeRed"
Else
    If m_Enabled Then
        m_ModeRed = New_ModeRed
        Call AmpelAnzeigen
        Call Eventauslsen
        PropertyChanged "ModeRed"
    End If
End If

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,False
Public Property Get ModeGreen() As Boolean
Attribute ModeGreen.VB_Description = "gibt den Aktivierungs-Modus zurck oder legt ihn fest"
    ModeGreen = m_ModeGreen
End Property

Public Property Let ModeGreen(ByVal New_ModeGreen As Boolean)
On Error GoTo Fehlerbehandlung

If Ambient.UserMode = False Then
    m_ModeGreen = New_ModeGreen
    Call AmpelAnzeigen
    PropertyChanged "ModeGreen"
Else
    If m_Enabled Then
        m_ModeGreen = New_ModeGreen
        Call AmpelAnzeigen
        Call Eventauslsen
        PropertyChanged "ModeGreen"
    End If
End If

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,False
Public Property Get ModeYellow() As Boolean
Attribute ModeYellow.VB_Description = "gibt den Aktivierungs-Modus zurck oder legt ihn fest"
    ModeYellow = m_ModeYellow
End Property

Public Property Let ModeYellow(ByVal New_ModeYellow As Boolean)
On Error GoTo Fehlerbehandlung

If Ambient.UserMode = False Then
    m_ModeYellow = New_ModeYellow
    Call AmpelAnzeigen
    PropertyChanged "ModeYellow"
Else
    If m_Enabled Then
        m_ModeYellow = New_ModeYellow
        Call AmpelAnzeigen
        Call Eventauslsen
        PropertyChanged "ModeYellow"
    End If
End If

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

Private Sub Eventauslsen()
If tmrFlash.Enabled = False Then
    If m_ModeGreen = True And m_ModeYellow = False And m_ModeRed = False Then
        RaiseEvent ByGreen
    ElseIf m_ModeGreen = False And m_ModeYellow = True And m_ModeRed = False Then
        RaiseEvent ByYellow
    ElseIf m_ModeGreen = False And m_ModeYellow = False And m_ModeRed = True Then
        RaiseEvent ByRed
    ElseIf m_ModeGreen = False And m_ModeYellow = True And m_ModeRed = True Then
        RaiseEvent ByRedYellow
    End If
End If
End Sub

Private Sub tmrFlash_Timer()
    m_ModeGreen = False
    m_ModeYellow = Not m_ModeYellow
    m_ModeRed = False
    Call AmpelAnzeigen
    RaiseEvent ByFlash
End Sub

Private Sub tmrYellowPhase_Timer()
'bei Ende der GelbPhase
If m_AutomaticMode And m_Enabled Then
    ChangeGreenColor False
    ChangeYellowColor False
    ChangeRedColor True
    tmrYellowPhase.Interval = 0
    tmrYellowPhase.Enabled = False
    tmrRedPhase.Interval = m_IntervalRedPhase
    tmrRedPhase.Enabled = True
    Call AmpelAnzeigen
    Call Eventauslsen
End If
End Sub

Private Sub tmrGreenPhase_Timer()
'bei Ende der GrnPhase
If m_AutomaticMode And m_Enabled Then
    ChangeGreenColor False
    ChangeYellowColor True
    ChangeRedColor False
    tmrGreenPhase.Interval = 0
    tmrGreenPhase.Enabled = False
    tmrYellowPhase.Interval = m_IntervalYellowPhase
    tmrYellowPhase.Enabled = True
    Call AmpelAnzeigen
    Call Eventauslsen
End If
End Sub

Private Sub tmrRedYellowPhase_Timer()
'bei Ende der Rot- und GelbPhase
If m_AutomaticMode And m_Enabled Then
    ChangeGreenColor True
    ChangeYellowColor False
    ChangeRedColor False
    tmrRedYellowPhase.Interval = 0
    tmrRedYellowPhase.Enabled = False
    tmrGreenPhase.Interval = m_IntervalGreenPhase
    tmrGreenPhase.Enabled = True
    Call AmpelAnzeigen
    Call Eventauslsen
End If
End Sub

Private Sub tmrRedPhase_Timer()
'bei Ende der RotPhase
If m_AutomaticMode And m_Enabled Then
    ChangeGreenColor False
    ChangeYellowColor True
    ChangeRedColor True
    tmrRedPhase.Interval = 0
    tmrRedPhase.Enabled = False
    tmrRedYellowPhase.Interval = m_IntervalRedYellowPhase
    tmrRedYellowPhase.Enabled = True
    Call AmpelAnzeigen
    Call Eventauslsen
End If
End Sub

Private Sub UserControl_GotFocus()
hasFocus = True
    Call AmpelAnzeigen
End Sub

Private Sub UserControl_Initialize()
 InitCommonControls
End Sub

'Eigenschaften fr Benutzersteuerelement initialisieren
Private Sub UserControl_InitProperties()
    m_ModeRed = m_def_ModeRed
    m_ModeGreen = m_def_ModeGreen
    m_ModeYellow = m_def_ModeYellow
    m_Orientation = m_def_Orientation
    UserControl.Width = 800
    UserControl.Height = 2000
    m_BorderStyle = m_def_BorderStyle
    m_FillColor = m_def_FillColor
    m_Enabled = m_def_Enabled
    m_FlashMode = m_def_FlashMode
    m_AutomaticMode = m_def_AutomaticMode
    m_Gradient = m_def_Gradient
    m_BackColor = m_def_BackColor
    m_BackColor2 = m_def_BackColor2
    m_GradientOrientation = m_def_GradientOrientation
    m_GreenOrientation = m_def_GreenOrientation
    m_IntervalGreenPhase = m_def_IntervalGreenPhase
    m_IntervalYellowPhase = m_def_IntervalYellowPhase
    m_IntervalRedPhase = m_def_IntervalRedPhase
    m_IntervalRedYellowPhase = m_def_IntervalRedYellowPhase
    m_ShowArrows = m_def_ShowArrows
    m_OrientationArrowhead = m_def_OrientationArrowhead
    m_ShowFocusRect = m_def_ShowFocusRect
    m_DrawWidth = m_def_DrawWidth
End Sub

Private Sub UserControl_LostFocus()
hasFocus = False
    Call AmpelAnzeigen
End Sub

Private Sub UserControl_Paint()
    Call AmpelAnzeigen
End Sub

'Eigenschaftenwerte vom Speicher laden
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
On Error GoTo Fehlerbehandlung

With PropBag
    m_ModeRed = .ReadProperty("ModeRed", m_def_ModeRed)
    m_ModeGreen = .ReadProperty("ModeGreen", m_def_ModeGreen)
    m_ModeYellow = .ReadProperty("ModeYellow", m_def_ModeYellow)
    m_Orientation = .ReadProperty("Orientation", m_def_Orientation)
    m_BackColor = .ReadProperty("BackColor", m_def_BackColor)
    m_BackColor2 = .ReadProperty("BackColor2", m_def_BackColor2)
    m_BorderStyle = .ReadProperty("BorderStyle", m_def_BorderStyle)
    m_FillColor = .ReadProperty("FillColor", m_def_FillColor)
    tmrFlash.Interval = .ReadProperty("FlashInterval", 0)
    m_Enabled = .ReadProperty("Enabled", m_def_Enabled)
    m_FlashMode = .ReadProperty("FlashMode", m_def_FlashMode)
    m_AutomaticMode = .ReadProperty("AutomaticMode", m_def_AutomaticMode)
    m_IntervalGreenPhase = .ReadProperty("IntervalGreenPhase", m_def_IntervalGreenPhase)
    m_IntervalYellowPhase = .ReadProperty("IntervalYellowPhase", m_def_IntervalYellowPhase)
    m_IntervalRedPhase = .ReadProperty("IntervalRedPhase", m_def_IntervalRedPhase)
    m_IntervalRedYellowPhase = .ReadProperty("IntervalRedYellowPhase", m_def_IntervalRedYellowPhase)
    m_Gradient = .ReadProperty("Gradient", m_def_Gradient)
    m_GradientOrientation = .ReadProperty("GradientOrientation", m_def_GradientOrientation)
    m_GreenOrientation = .ReadProperty("GreenOrientation", m_def_GreenOrientation)
    Set MouseIcon = .ReadProperty("MouseIcon", Nothing)
    UserControl.MousePointer = .ReadProperty("MousePointer", 0)
    m_ShowArrows = .ReadProperty("ShowArrows", m_def_ShowArrows)
    m_OrientationArrowhead = .ReadProperty("OrientationArrowhead", m_def_OrientationArrowhead)
    m_DrawWidth = .ReadProperty("DrawWidth", m_def_DrawWidth)
    m_ShowFocusRect = .ReadProperty("ShowFocusRect", m_def_ShowFocusRect)
End With

    UserControl.BackColor = m_BackColor

With UserControl
    Select Case m_BorderStyle
        Case 0
            BorderStyleRaised .hwnd, True
            .BorderStyle = m_BorderStyle
        Case 1
            BorderStyleRaised .hwnd, True
            .BorderStyle = m_BorderStyle
        Case 2
            .BorderStyle = 0
            BorderStyleRaised .hwnd, False
        Case 3
            .BorderStyle = 1
            BorderStyleRaised .hwnd, False
    End Select
End With
    tmrGreenPhase.Interval() = m_IntervalGreenPhase
    tmrYellowPhase.Interval() = m_IntervalYellowPhase
    tmrRedPhase.Interval() = m_IntervalRedPhase
    tmrRedYellowPhase.Interval() = m_IntervalRedYellowPhase

    If Ambient.UserMode = False Then
        tmrFlash.Enabled = False
        tmrGreenPhase.Enabled = False
        tmrYellowPhase.Enabled = False
        tmrRedPhase.Enabled = False
        tmrRedYellowPhase.Enabled = False
    Else
        If m_Enabled = False Then
            m_ModeGreen = False
            m_ModeYellow = False
            m_ModeRed = False
        End If
        tmrFlash.Enabled = m_FlashMode
    End If

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub UserControl_Resize()
On Error GoTo Fehlerbehandlung
    On Error Resume Next

'automatisches Anpassen
With UserControl
    .Cls
       .FillStyle = vbSolid
    If .Width > .Height Then
        m_Orientation = Horizontal
       Radius = .ScaleWidth / 7.5
       Rand = (.ScaleWidth - (6 * Radius)) \ 4
       YPos = .ScaleHeight \ Innenabstand
    
       .FillColor = vbRed
       XPos = Rand + Radius
       UserControl.Circle (XPos, YPos), Radius
       
       .FillColor = vbYellow
       XPos = 2 * Rand + 3 * Radius
       UserControl.Circle (XPos, YPos), Radius
       
       .FillColor = vbGreen
        XPos = 3 * Rand + 5 * Radius
       UserControl.Circle (XPos, YPos), Radius
    Else
        m_Orientation = Vertikal
       Radius = .ScaleHeight / 7.5
       Rand = (.ScaleHeight - (6 * Radius)) \ 4
       YPos = .ScaleWidth \ Innenabstand
       
       .FillColor = vbRed
       XPos = Rand + Radius
       UserControl.Circle (YPos, XPos), Radius
       
       .FillColor = vbYellow
       XPos = 2 * Rand + 3 * Radius
       UserControl.Circle (YPos, XPos), Radius
       
       .FillColor = vbGreen
        XPos = 3 * Rand + 5 * Radius
       UserControl.Circle (YPos, XPos), Radius
    End If
    Call AmpelAnzeigen
    RaiseEvent Resize
End With

Exit Sub
Fehlerbehandlung:
End Sub

'Eigenschaftenwerte in den Speicher schreiben
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
On Error GoTo Fehlerbehandlung

With PropBag
    Call .WriteProperty("ModeRed", m_ModeRed, m_def_ModeRed)
    Call .WriteProperty("ModeGreen", m_ModeGreen, m_def_ModeGreen)
    Call .WriteProperty("ModeYellow", m_ModeYellow, m_def_ModeYellow)
    Call .WriteProperty("Orientation", m_Orientation, m_def_Orientation)
    Call .WriteProperty("BackColor", m_BackColor, m_def_BackColor)
    Call .WriteProperty("BackColor2", m_BackColor2, m_def_BackColor2)
    Call .WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
    Call .WriteProperty("FillColor", m_FillColor, m_def_FillColor)
    Call .WriteProperty("FlashInterval", tmrFlash.Interval, 0)
    Call .WriteProperty("Enabled", m_Enabled, m_def_Enabled)
    Call .WriteProperty("FlashMode", m_FlashMode, m_def_FlashMode)
    Call .WriteProperty("AutomaticMode", m_AutomaticMode, m_def_AutomaticMode)
    Call .WriteProperty("IntervalGreenPhase", m_IntervalGreenPhase, m_def_IntervalGreenPhase)
    Call .WriteProperty("IntervalYellowPhase", m_IntervalYellowPhase, m_def_IntervalYellowPhase)
    Call .WriteProperty("IntervalRedPhase", m_IntervalRedPhase, m_def_IntervalRedPhase)
    Call .WriteProperty("IntervalRedYellowPhase", m_IntervalRedYellowPhase, m_def_IntervalRedYellowPhase)
    Call .WriteProperty("Gradient", m_Gradient, m_def_Gradient)
    Call .WriteProperty("GradientOrientation", m_GradientOrientation, m_def_GradientOrientation)
    Call .WriteProperty("GreenOrientation", m_GreenOrientation, m_def_GreenOrientation)
    Call .WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call .WriteProperty("MousePointer", UserControl.MousePointer, 0)
    Call .WriteProperty("ShowArrows", m_ShowArrows, m_def_ShowArrows)
    Call .WriteProperty("OrientationArrowhead", m_OrientationArrowhead, m_def_OrientationArrowhead)
    Call .WriteProperty("DrawWidth", m_DrawWidth, m_def_DrawWidth)
    Call .WriteProperty("ShowFocusRect", m_ShowFocusRect, m_def_ShowFocusRect)
End With

Exit Sub
Fehlerbehandlung:
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=14,0,0,0
Public Property Get Orientation() As enumOrientation
Attribute Orientation.VB_Description = "gibt die Ausrichtung der Ampel zurck oder legt sie fest"
    Orientation = m_Orientation
End Property

Public Property Let Orientation(ByVal New_Orientation As enumOrientation)
    Dim tmpBreite As Single
With UserControl
    If New_Orientation <> m_Orientation Then
       m_Orientation = New_Orientation
       Call AmpelAnzeigen
    End If
End With
    PropertyChanged "Orientation"
End Property

Private Sub AmpelAnzeigen()
On Error GoTo Fehlerbehandlung

UserControl.Cls

If m_Gradient Then
    Call Gradientanzeigen
End If

UserControl.DrawWidth = 1

    If m_ModeRed = True Then
       ChangeRedColor True
    Else
       ChangeRedColor False
    End If
    If m_ModeYellow = True Then
       ChangeYellowColor True
    Else
       ChangeYellowColor False
    End If
    If m_ModeGreen = True Then
       ChangeGreenColor True
    Else
       ChangeGreenColor False
    End If

'prfen ob Richtungspfeile angezeigt werden sollen
If m_ShowArrows = True Then
    UserControl.DrawWidth = m_DrawWidth
    'die Ausrichtung prfen
    If m_Orientation = Horizontal Then
        If m_GreenOrientation = Rechts Then
            If m_OrientationArrowhead = [Fahrtrichtung geradeaus] Then
                Call HorizontalFahrtrichtungGeradeaus(True)
            ElseIf m_OrientationArrowhead = [Fahrtrichtung links] Then
                Call HorizontalFahrtrichtungRechts(False)
            ElseIf m_OrientationArrowhead = [Fahrtrichtung rechts] Then
                Call HorizontalFahrtrichtungRechts(True)
            ElseIf m_OrientationArrowhead = Fugnger Then
                Call HorizontalFugnger(True)
            End If
        ElseIf m_GreenOrientation = Links Then
            If m_OrientationArrowhead = [Fahrtrichtung geradeaus] Then
                Call HorizontalFahrtrichtungGeradeaus(False)
            ElseIf m_OrientationArrowhead = [Fahrtrichtung links] Then
                Call HorizontalFahrtrichtungRechts(True)
            ElseIf m_OrientationArrowhead = [Fahrtrichtung rechts] Then
                Call HorizontalFahrtrichtungRechts(False)
            ElseIf m_OrientationArrowhead = Fugnger Then
                Call HorizontalFugnger(False)
            End If
        End If
    Else
        If m_GreenOrientation = Standard Then
            If m_OrientationArrowhead = [Fahrtrichtung geradeaus] Then
                Call VertikalFahrtrichtungGeradeaus(True)
            ElseIf m_OrientationArrowhead = [Fahrtrichtung links] Then
                Call VertikalFahrtrichtungRechts(True)
            ElseIf m_OrientationArrowhead = [Fahrtrichtung rechts] Then
                Call VertikalFahrtrichtungRechts(False)
            ElseIf m_OrientationArrowhead = Fugnger Then
                Call VertikalFugnger(True)
            End If
        ElseIf m_GreenOrientation = Oben Then
            If m_OrientationArrowhead = [Fahrtrichtung geradeaus] Then
                Call VertikalFahrtrichtungGeradeaus(False)
            ElseIf m_OrientationArrowhead = [Fahrtrichtung links] Then
                Call VertikalFahrtrichtungRechts(False)
            ElseIf m_OrientationArrowhead = [Fahrtrichtung rechts] Then
                Call VertikalFahrtrichtungRechts(True)
            ElseIf m_OrientationArrowhead = Fugnger Then
                Call VertikalFugnger(False)
            End If
        End If
    End If
End If

If m_ShowFocusRect = True Then
    If hasFocus = True Then
    Dim CtlRect As RECT
        With CtlRect
            .Left = 2
            .Top = 2
            .Right = UserControl.ScaleWidth - 2
            .Bottom = UserControl.ScaleHeight - 2
        End With
    
    Call DrawFocusRect(UserControl.hDC, CtlRect)
    End If
End If

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub ChangeRedColor(Modus As Boolean)
On Error GoTo Fehlerbehandlung

With UserControl
    If Modus = True Then
        m_ModeRed = True
        .FillColor = FillColorRed
    Else
        m_ModeRed = False
        .FillColor = m_FillColor
    End If
    
    If m_Orientation = Vertikal Then
        If m_GreenOrientation = Standard Then
            XPos = UserControl.ScaleWidth \ 2
            YPos = Rand + Radius
            UserControl.Circle (XPos, YPos), Radius
        
        Else
            XPos = UserControl.ScaleWidth \ 2
            YPos = 3 * Rand + 5 * Radius
            UserControl.Circle (XPos, YPos), Radius
            
        End If
    Else
        If m_GreenOrientation = Rechts Then
            YPos = UserControl.ScaleHeight \ 2
            XPos = Rand + Radius
            UserControl.Circle (XPos, YPos), Radius
        Else
            YPos = UserControl.ScaleHeight \ 2
            XPos = 3 * Rand + 5 * Radius
            UserControl.Circle (XPos, YPos), Radius
        End If
    End If
End With

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub ChangeYellowColor(Modus As Boolean)
On Error GoTo Fehlerbehandlung

    If Modus = True Then
       UserControl.FillColor = FillColorYellow
       m_ModeYellow = True
    Else
       m_ModeYellow = False
       UserControl.FillColor = m_FillColor
    End If
    
    If m_Orientation = Vertikal Then
       XPos = UserControl.ScaleWidth \ 2
       YPos = 2 * Rand + 3 * Radius
        UserControl.Circle (XPos, YPos), Radius
   
   Else
       YPos = UserControl.ScaleHeight \ 2
       XPos = 2 * Rand + 3 * Radius
        UserControl.Circle (XPos, YPos), Radius
    
    End If

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub ChangeGreenColor(Modus As Boolean)
On Error GoTo Fehlerbehandlung

    If Modus = True Then
       UserControl.FillColor = FillColorGreen
       m_ModeGreen = True
    Else
       m_ModeGreen = False
       UserControl.FillColor = m_FillColor
    End If
    
    If m_Orientation = Vertikal Then
        If m_GreenOrientation = Standard Then
            XPos = UserControl.ScaleWidth \ 2
            YPos = 3 * Rand + 5 * Radius
            UserControl.Circle (XPos, YPos), Radius
            
        Else
            XPos = UserControl.ScaleWidth \ 2
            YPos = Rand + Radius
            UserControl.Circle (XPos, YPos), Radius
        
        End If
    Else
        If m_GreenOrientation = Rechts Then
            YPos = UserControl.ScaleHeight \ 2
            XPos = 3 * Rand + 5 * Radius
            UserControl.Circle (XPos, YPos), Radius
        
        Else
            YPos = UserControl.ScaleHeight \ 2
            XPos = Rand + Radius
            UserControl.Circle (XPos, YPos), Radius
        
        End If
    End If

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub HorizontalLinienzeichnenGeradeaus(ByVal Rechts As Boolean, ByVal Radius As Currency, _
ByVal Rand As Currency, ByVal YPos As Currency, ByVal XPos As Currency)
On Error GoTo Fehlerbehandlung

'die Linien entsprechend zeichnen
    If Rechts = True Then
       UserControl.Line (XPos - Rand, YPos)-(XPos + (Radius / 2), YPos)
       UserControl.Line (XPos, YPos - Radius + (Rand / Innenabstand))-(XPos - (Rand * 2), YPos)
       UserControl.Line (XPos, YPos + Radius - (Rand / Innenabstand))-(XPos - (Rand * 2), YPos)
    Else
       UserControl.Line (XPos - Rand, YPos)-(XPos + (Radius / 2), YPos)
       UserControl.Line (XPos, YPos - Radius + (Rand / Innenabstand))-(XPos + (Rand * 2), YPos)
       UserControl.Line (XPos, YPos + Radius - (Rand / Innenabstand))-(XPos + (Rand * 2), YPos)
    End If

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub HorizontalFahrtrichtungGeradeaus(ByVal GrnRechts As Boolean)
On Error GoTo Fehlerbehandlung

With UserControl

Radius = .ScaleWidth / 7.5
Rand = (.ScaleWidth - (6 * Radius)) \ 4
YPos = .ScaleHeight \ 2
XPos = Rand + Radius
       
    If GrnRechts = True Then
'       .ForeColor = vbRed
       Call HorizontalLinienzeichnenGeradeaus(True, Radius, Rand, YPos, XPos)
       
'       .ForeColor = vbYellow
       XPos = 2 * Rand + 3 * Radius
       Call HorizontalLinienzeichnenGeradeaus(True, Radius, Rand, YPos, XPos)
       
'       .ForeColor = vbBlack
       XPos = 3 * Rand + 5 * Radius
       Call HorizontalLinienzeichnenGeradeaus(True, Radius, Rand, YPos, XPos)
    
    Else
       XPos = Rand + Radius
       Call HorizontalLinienzeichnenGeradeaus(False, Radius, Rand, YPos, XPos)
       
       XPos = 2 * Rand + 3 * Radius
       Call HorizontalLinienzeichnenGeradeaus(False, Radius, Rand, YPos, XPos)
       
       XPos = 3 * Rand + 5 * Radius
       Call HorizontalLinienzeichnenGeradeaus(False, Radius, Rand, YPos, XPos)
    
    End If
'       .ForeColor = vbBlack
End With

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub HorizontalLinienzeichnenRechts(ByVal Rechts As Boolean, ByVal Radius As Currency, _
ByVal Rand As Currency, ByVal YPos As Currency, ByVal XPos As Currency)
On Error GoTo Fehlerbehandlung

'die Linien entsprechend zeichnen
    If Rechts = True Then
       UserControl.Line (XPos, YPos + (Radius / 2))-(XPos, YPos - Rand)
       UserControl.Line (XPos, YPos - Radius + (Rand * Innenabstand))-(XPos - (Rand * 2), YPos)
       UserControl.Line (XPos, YPos - Radius + (Rand * Innenabstand))-(XPos + (Rand * 2), YPos)
    Else
       UserControl.Line (XPos, YPos + Rand)-(XPos, YPos - (Radius / 2))
       UserControl.Line (XPos, YPos + Radius - (Rand * Innenabstand))-(XPos - (Rand * 2), YPos)
       UserControl.Line (XPos, YPos + Radius - (Rand * Innenabstand))-(XPos + (Rand * 2), YPos)
    End If

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub HorizontalFahrtrichtungRechts(ByVal Rechts As Boolean)
On Error GoTo Fehlerbehandlung

With UserControl

Radius = .ScaleWidth / 7.5
Rand = (.ScaleWidth - (6 * Radius)) \ 4
YPos = .ScaleHeight \ 2
XPos = Rand + Radius
       
    If Rechts = True Then
       Call HorizontalLinienzeichnenRechts(True, Radius, Rand, YPos, XPos)
       
       XPos = 2 * Rand + 3 * Radius
       Call HorizontalLinienzeichnenRechts(True, Radius, Rand, YPos, XPos)
       
       XPos = 3 * Rand + 5 * Radius
       Call HorizontalLinienzeichnenRechts(True, Radius, Rand, YPos, XPos)
    
    Else
       XPos = Rand + Radius
       Call HorizontalLinienzeichnenRechts(False, Radius, Rand, YPos, XPos)

       XPos = 2 * Rand + 3 * Radius
       Call HorizontalLinienzeichnenRechts(False, Radius, Rand, YPos, XPos)

       XPos = 3 * Rand + 5 * Radius
       Call HorizontalLinienzeichnenRechts(False, Radius, Rand, YPos, XPos)
    
    End If
'       .ForeColor = vbBlack
End With

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub VertikalLinienzeichnenGeradeaus(ByVal Standard As Boolean, ByVal Radius As Currency, _
ByVal Rand As Currency, ByVal YPos As Currency, ByVal XPos As Currency)
On Error GoTo Fehlerbehandlung

'die Linien entsprechend zeichnen
    If Standard = True Then
       UserControl.Line (XPos, YPos + (Radius / 2))-(XPos, YPos - Rand)
       UserControl.Line (XPos, YPos - Radius + (Rand * Innenabstand))-(XPos - (Rand * 2), YPos)
       UserControl.Line (XPos, YPos - Radius + (Rand * Innenabstand))-(XPos + (Rand * 2), YPos)
    Else
       UserControl.Line (XPos, YPos + Rand)-(XPos, YPos - (Radius / 2))
       UserControl.Line (XPos, YPos + Radius - (Rand * Innenabstand))-(XPos - (Rand * 2), YPos)
       UserControl.Line (XPos, YPos + Radius - (Rand * Innenabstand))-(XPos + (Rand * 2), YPos)
    End If

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub VertikalFahrtrichtungGeradeaus(ByVal Standard As Boolean)
On Error GoTo Fehlerbehandlung

With UserControl

Radius = .ScaleHeight / 7.5
Rand = (.ScaleHeight - (6 * Radius)) \ 4
XPos = UserControl.ScaleWidth \ 2
YPos = Rand + Radius
       
    If Standard = True Then
       Call VertikalLinienzeichnenGeradeaus(True, Radius, Rand, YPos, XPos)
       
       YPos = 2 * Rand + 3 * Radius
       Call VertikalLinienzeichnenGeradeaus(True, Radius, Rand, YPos, XPos)
       
       YPos = 3 * Rand + 5 * Radius
       Call VertikalLinienzeichnenGeradeaus(True, Radius, Rand, YPos, XPos)
    
    Else
       Call VertikalLinienzeichnenGeradeaus(False, Radius, Rand, YPos, XPos)
       
       YPos = 2 * Rand + 3 * Radius
       Call VertikalLinienzeichnenGeradeaus(False, Radius, Rand, YPos, XPos)
       
       YPos = 3 * Rand + 5 * Radius
       Call VertikalLinienzeichnenGeradeaus(False, Radius, Rand, YPos, XPos)
    
    End If

End With

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub VertikalLinienzeichnenRechts(ByVal Rechts As Boolean, ByVal Radius As Currency, _
ByVal Rand As Currency, ByVal YPos As Currency, ByVal XPos As Currency)
On Error GoTo Fehlerbehandlung

'die Linien entsprechend zeichnen
    If Rechts = True Then
       UserControl.Line (XPos - Rand, YPos)-(XPos + (Radius / 2), YPos)
       UserControl.Line (XPos, YPos - Radius + (Rand / Innenabstand))-(XPos - (Rand * 2), YPos)
       UserControl.Line (XPos, YPos + Radius - (Rand / Innenabstand))-(XPos - (Rand * 2), YPos)
    Else
       UserControl.Line (XPos - Rand, YPos)-(XPos + (Radius / 2), YPos)
       UserControl.Line (XPos, YPos - Radius + (Rand / Innenabstand))-(XPos + (Rand * 2), YPos)
       UserControl.Line (XPos, YPos + Radius - (Rand / Innenabstand))-(XPos + (Rand * 2), YPos)
    End If

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub VertikalFahrtrichtungRechts(ByVal Rechts As Boolean)
On Error GoTo Fehlerbehandlung

With UserControl

Radius = .ScaleHeight / 7.5
Rand = (.ScaleHeight - (6 * Radius)) \ 4
XPos = UserControl.ScaleWidth \ 2
YPos = Rand + Radius
       
    If Rechts = True Then
       Call VertikalLinienzeichnenRechts(True, Radius, Rand, YPos, XPos)
       
       YPos = 2 * Rand + 3 * Radius
       Call VertikalLinienzeichnenRechts(True, Radius, Rand, YPos, XPos)
       
       YPos = 3 * Rand + 5 * Radius
       Call VertikalLinienzeichnenRechts(True, Radius, Rand, YPos, XPos)
    
    Else
       Call VertikalLinienzeichnenRechts(False, Radius, Rand, YPos, XPos)
       
       YPos = 2 * Rand + 3 * Radius
       Call VertikalLinienzeichnenRechts(False, Radius, Rand, YPos, XPos)
       
       YPos = 3 * Rand + 5 * Radius
       Call VertikalLinienzeichnenRechts(False, Radius, Rand, YPos, XPos)
    
    End If
'       .ForeColor = vbBlack
End With

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub HorizontalFugngerzeichnen(ByVal Rechts As Boolean, ByVal Radius As Currency, _
ByVal Rand As Currency, ByVal YPos As Currency, ByVal XPos As Currency)
On Error GoTo Fehlerbehandlung

'die Linien entsprechend zeichnen
    If Rechts = True Then
       UserControl.FillColor = vbBlack
       UserControl.Circle (XPos - (Radius / 2), YPos), Radius / 5
       
       UserControl.Line (XPos - (Radius / 3), YPos)-(XPos + (Radius / 3), YPos)
       
       UserControl.Line (XPos, YPos - Radius + (Rand / Innenabstand) * 1.5)-(XPos, YPos)
       UserControl.Line (XPos, YPos + Radius - (Rand / Innenabstand) * 1.5)-(XPos, YPos)
       
       UserControl.Line (XPos + (Rand * 2), YPos - Rand)-(XPos + (Rand / 2), YPos)
       UserControl.Line (XPos + (Rand * 2), YPos + Rand)-(XPos + (Rand / 2), YPos)
    Else
       UserControl.FillColor = vbBlack
       UserControl.Circle (XPos + (Radius / 2), YPos), Radius / 5
       
       UserControl.Line (XPos - (Radius / 3), YPos)-(XPos + (Radius / 3), YPos)
       
       UserControl.Line (XPos, YPos - Radius + (Rand / Innenabstand) * 1.5)-(XPos, YPos)
       UserControl.Line (XPos, YPos + Radius - (Rand / Innenabstand) * 1.5)-(XPos, YPos)
       
       UserControl.Line (XPos - (Rand * 2), YPos - Rand)-(XPos - (Rand / 2), YPos)
       UserControl.Line (XPos - (Rand * 2), YPos + Rand)-(XPos - (Rand / 2), YPos)
    End If

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub HorizontalFugnger(ByVal GrnRechts As Boolean)
On Error GoTo Fehlerbehandlung

With UserControl

Radius = .ScaleWidth / 7.5
Rand = (.ScaleWidth - (6 * Radius)) \ 4
YPos = .ScaleHeight \ 2
XPos = Rand + Radius
       
    If GrnRechts = True Then
'       .ForeColor = vbRed
       Call HorizontalFugngerzeichnen(True, Radius, Rand, YPos, XPos)
       
'       .ForeColor = vbYellow
       XPos = 2 * Rand + 3 * Radius
       Call HorizontalFugngerzeichnen(True, Radius, Rand, YPos, XPos)

'       .ForeColor = vbBlack
       XPos = 3 * Rand + 5 * Radius
       Call HorizontalFugngerzeichnen(True, Radius, Rand, YPos, XPos)
    
    Else
       XPos = Rand + Radius
       Call HorizontalFugngerzeichnen(False, Radius, Rand, YPos, XPos)
       
       XPos = 2 * Rand + 3 * Radius
       Call HorizontalFugngerzeichnen(False, Radius, Rand, YPos, XPos)
       
       XPos = 3 * Rand + 5 * Radius
       Call HorizontalFugngerzeichnen(False, Radius, Rand, YPos, XPos)
    
    End If
'       .ForeColor = vbBlack
End With

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub VertikalFugngerzeichnen(ByVal Standard As Boolean, ByVal Radius As Currency, _
ByVal Rand As Currency, ByVal YPos As Currency, ByVal XPos As Currency)
On Error GoTo Fehlerbehandlung

'die Linien entsprechend zeichnen
    If Standard = True Then
       UserControl.FillColor = vbBlack
       UserControl.Circle (XPos, YPos - (Radius / 2)), Radius / 5
       
       UserControl.Line (XPos, YPos - (Radius / 3))-(XPos, YPos + (Radius / 3))
       
       UserControl.Line (XPos - Radius + (Rand / Innenabstand) * 1.5, YPos)-(XPos, YPos)
       UserControl.Line (XPos + Radius - (Rand / Innenabstand) * 1.5, YPos)-(XPos, YPos)
       
       UserControl.Line (XPos - Rand, YPos + (Rand * 2))-(XPos, YPos + (Rand / 2))
       UserControl.Line (XPos + Rand, YPos + (Rand * 2))-(XPos, YPos + (Rand / 2))
    Else
       UserControl.FillColor = vbBlack
       UserControl.Circle (XPos, YPos + (Radius / 2)), Radius / 5
       
       UserControl.Line (XPos, YPos - (Radius / 3))-(XPos, YPos + (Radius / 3))
       
       UserControl.Line (XPos - Radius + (Rand / Innenabstand) * 1.5, YPos)-(XPos, YPos)
       UserControl.Line (XPos + Radius - (Rand / Innenabstand) * 1.5, YPos)-(XPos, YPos)
       
       UserControl.Line (XPos - Rand, YPos - (Rand * 2))-(XPos, YPos - (Rand / 2))
       UserControl.Line (XPos + Rand, YPos - (Rand * 2))-(XPos, YPos - (Rand / 2))
    End If

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub VertikalFugnger(ByVal Standard As Boolean)
On Error GoTo Fehlerbehandlung

With UserControl

Radius = .ScaleHeight / 7.5
Rand = (.ScaleHeight - (6 * Radius)) \ 4
XPos = UserControl.ScaleWidth \ 2
YPos = Rand + Radius
       
    If Standard = True Then
       Call VertikalFugngerzeichnen(True, Radius, Rand, YPos, XPos)
       
       YPos = 2 * Rand + 3 * Radius
       Call VertikalFugngerzeichnen(True, Radius, Rand, YPos, XPos)
       
       YPos = 3 * Rand + 5 * Radius
       Call VertikalFugngerzeichnen(True, Radius, Rand, YPos, XPos)
    
    Else
       Call VertikalFugngerzeichnen(False, Radius, Rand, YPos, XPos)
       
       YPos = 2 * Rand + 3 * Radius
       Call VertikalFugngerzeichnen(False, Radius, Rand, YPos, XPos)
       
       YPos = 3 * Rand + 5 * Radius
       Call VertikalFugngerzeichnen(False, Radius, Rand, YPos, XPos)
    
    End If

End With

Exit Sub
Fehlerbehandlung:
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=UserControl,UserControl,-1,hWnd
Public Property Get hwnd() As Long
Attribute hwnd.VB_Description = "Gibt eine Zugriffsnummer (von Microsoft Windows) auf ein Objektfenster zurck."
    hwnd = UserControl.hwnd
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=5
Public Sub Refresh()
Attribute Refresh.VB_Description = "Erzwingt ein vollstndiges Neuzeichnen eines Objekts."
    Call AmpelAnzeigen
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=14,0,0,0
Public Property Get BorderStyle() As eBorderStyle
Attribute BorderStyle.VB_Description = "gibt den Rahmenstil zurck oder legt ihn fest"
    BorderStyle = m_BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As eBorderStyle)
On Error GoTo Fehlerbehandlung

    m_BorderStyle = New_BorderStyle
With UserControl
    Select Case m_BorderStyle
        Case 0
            BorderStyleRaised .hwnd, True
            .BorderStyle = m_BorderStyle
        Case 1
            BorderStyleRaised .hwnd, True
            .BorderStyle = m_BorderStyle
        Case 2
            .BorderStyle = 0
            BorderStyleRaised .hwnd, False
        Case 3
            .BorderStyle = 1
            BorderStyleRaised .hwnd, False
    End Select
End With
    PropertyChanged "BorderStyle"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,&H00404040&
Public Property Get FillColor() As OLE_COLOR
Attribute FillColor.VB_Description = "Gibt die Farbe zurck, die zum Auffllen von Figuren, Kreisen und Feldern verwendet wird, oder legt diese fest."
    FillColor = m_FillColor
End Property

Public Property Let FillColor(ByVal New_FillColor As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_FillColor = New_FillColor
    Call AmpelAnzeigen
    PropertyChanged "FillColor"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=tmrFlash,tmrFlash,-1,Interval
Public Property Get FlashInterval() As Long
Attribute FlashInterval.VB_Description = "Gibt die Anzahl der Millisekunden zwischen Aufrufen an das Timer-Ereignis eines Zeitgeber-Steuerelements zurck oder legt diese fest."
    FlashInterval = tmrFlash.Interval
End Property

Public Property Let FlashInterval(ByVal New_FlashInterval As Long)
On Error GoTo Fehlerbehandlung

If New_FlashInterval < 0 Then
    Exit Property
Else
    tmrFlash.Interval() = New_FlashInterval
    PropertyChanged "FlashInterval"
End If

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "gibt die Aktivierung zurck oder legt sie fest"
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
On Error GoTo Fehlerbehandlung

    m_Enabled = New_Enabled
If Ambient.UserMode Then
    If m_Enabled = False Then
        tmrFlash.Enabled = False
        tmrGreenPhase.Enabled = False
        tmrYellowPhase.Enabled = False
        tmrRedPhase.Enabled = False
        tmrRedYellowPhase.Enabled = False
        m_ModeGreen = False
        m_ModeYellow = False
        m_ModeRed = False
        RaiseEvent ByDeActivate
    Else
        m_ModeGreen = False
        m_ModeYellow = True
        m_ModeRed = False
            RaiseEvent ByActivate
        If m_FlashMode Then
            tmrFlash.Enabled = True
            RaiseEvent ByFlash
            tmrGreenPhase.Enabled = False
            tmrYellowPhase.Enabled = False
            tmrRedPhase.Enabled = False
            tmrRedYellowPhase.Enabled = False
        Else
            If m_AutomaticMode Then
                tmrYellowPhase.Interval = m_IntervalYellowPhase
                tmrYellowPhase.Enabled = True
            End If
            RaiseEvent ByYellow
        End If
    End If
End If
    Call AmpelAnzeigen
    PropertyChanged "Enabled"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,False
Public Property Get FlashMode() As Boolean
Attribute FlashMode.VB_Description = "gibt den BlinkModus zurck oder legt ihn fest"
    FlashMode = m_FlashMode
End Property

Public Property Let FlashMode(ByVal New_FlashMode As Boolean)
On Error GoTo Fehlerbehandlung

    m_FlashMode = New_FlashMode
If Ambient.UserMode Then
    If m_Enabled Then
        tmrFlash.Enabled = m_FlashMode
        If tmrFlash.Enabled Then
            tmrFlash_Timer
            tmrGreenPhase.Interval = 0
            tmrGreenPhase.Enabled = False
            tmrYellowPhase.Interval = 0
            tmrYellowPhase.Enabled = False
            tmrRedPhase.Interval = 0
            tmrRedPhase.Enabled = False
            tmrRedYellowPhase.Interval = 0
            tmrRedYellowPhase.Enabled = False
        Else
            If m_AutomaticMode Then
                tmrGreenPhase.Interval = 0
                tmrGreenPhase.Enabled = False
                tmrYellowPhase.Interval = m_IntervalYellowPhase
                tmrYellowPhase.Enabled = True
                m_ModeYellow = True
                tmrRedPhase.Interval = 0
                tmrRedPhase.Enabled = False
                tmrRedYellowPhase.Interval = 0
                tmrRedYellowPhase.Enabled = False
            Else
                m_ModeGreen = False
                m_ModeYellow = True
                m_ModeRed = False
            End If
                RaiseEvent ByYellow
        End If
    End If
End If
    Call AmpelAnzeigen
    PropertyChanged "FlashMode"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,False
Public Property Get AutomaticMode() As Boolean
Attribute AutomaticMode.VB_Description = "gibt die automatische nderung der Ampel zurck oder legt sie fest"
    AutomaticMode = m_AutomaticMode
End Property

Public Property Let AutomaticMode(ByVal New_AutomaticMode As Boolean)
On Error GoTo Fehlerbehandlung

    m_AutomaticMode = New_AutomaticMode
If Ambient.UserMode Then
    If m_Enabled And m_AutomaticMode And m_FlashMode = False Then
        tmrFlash.Enabled = False
        tmrGreenPhase.Interval = 0
        tmrGreenPhase.Enabled = False
        m_ModeGreen = False
        m_ModeRed = False
        tmrRedPhase.Interval = 0
        tmrRedPhase.Enabled = False
        tmrRedYellowPhase.Interval = 0
        tmrRedYellowPhase.Enabled = False
        m_ModeYellow = True
        tmrYellowPhase.Interval = m_IntervalYellowPhase
        tmrYellowPhase.Enabled = True
        RaiseEvent ByYellow
        Call AmpelAnzeigen
    End If
End If
    PropertyChanged "AutomaticMode"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=UserControl,UserControl,-1,hDC
Public Property Get hDC() As Long
Attribute hDC.VB_Description = "Gibt eine Zugriffsnummer (von Microsoft Windows) fr den Gertekontext des Objekts zurck."
    hDC = UserControl.hDC
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,False
Public Property Get Gradient() As Boolean
Attribute Gradient.VB_Description = "legt fest ob ein Farbverlauf verwendet werden soll"
    Gradient = m_Gradient
End Property

Public Property Let Gradient(ByVal New_Gradient As Boolean)
On Error GoTo Fehlerbehandlung

    m_Gradient = New_Gradient
If m_Gradient Then
    Call Gradientanzeigen
Else
    UserControl.Cls
    UserControl.BackColor = m_BackColor
End If
    Call AmpelAnzeigen

    PropertyChanged "Gradient"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

Private Sub Gradientanzeigen()
On Error GoTo Fehlerbehandlung

    Dim AmpelGradient As Gradient
    Set AmpelGradient = New Gradient
    Dim r As RECT
        r.Left = 0
        r.Top = 0
        r.Right = UserControl.ScaleWidth
        r.Bottom = UserControl.ScaleHeight

    '**********************************************************
        Call AmpelGradient.DrawGradient(UserControl.hDC, VarPtr(r), _
        m_BackColor2, m_BackColor, m_GradientOrientation)
    '**********************************************************
Exit Sub
Fehlerbehandlung:
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,0
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Gibt die Hintergrundfarbe zurck, die verwendet wird, um Text und Grafik in einem Objekt anzuzeigen, oder legt diese fest."
    BackColor = m_BackColor
    
    'Umwandlen einer Systemfarbe nach RGB
    If (m_BackColor And &HFF000000) = &H80000000 Then _
    m_BackColor = GetSysColor(m_BackColor And &HFFFFFF)
    
    UserControl.BackColor = m_BackColor
    Call AmpelAnzeigen
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_BackColor = New_BackColor
    
    'Umwandlen einer Systemfarbe nach RGB
    If (m_BackColor And &HFF000000) = &H80000000 Then _
    m_BackColor = GetSysColor(m_BackColor And &HFFFFFF)
    
    UserControl.BackColor = m_BackColor
    Call AmpelAnzeigen
    PropertyChanged "BackColor"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,VbWhite
Public Property Get BackColor2() As OLE_COLOR
Attribute BackColor2.VB_Description = "Gibt die Hintergrundfarbe zurck, die verwendet wird, um Text und Grafik in einem Objekt anzuzeigen, oder legt diese fest."
    BackColor2 = m_BackColor2
    
    'Umwandlen einer Systemfarbe nach RGB
    If (m_BackColor2 And &HFF000000) = &H80000000 Then _
    m_BackColor2 = GetSysColor(m_BackColor2 And &HFFFFFF)
    
End Property

Public Property Let BackColor2(ByVal New_BackColor2 As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_BackColor2 = New_BackColor2
    
    'Umwandlen einer Systemfarbe nach RGB
    If (m_BackColor2 And &HFF000000) = &H80000000 Then _
    m_BackColor2 = GetSysColor(m_BackColor2 And &HFFFFFF)
    
    Call AmpelAnzeigen
    PropertyChanged "BackColor2"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=14,0,0,0
Public Property Get GradientOrientation() As eGradientOrientation
Attribute GradientOrientation.VB_Description = "gibt die Ausrichtung des Farbverlaufs zurck oder legt sie fest"
    GradientOrientation = m_GradientOrientation
End Property

Public Property Let GradientOrientation(ByVal New_GradientOrientation As eGradientOrientation)
On Error GoTo Fehlerbehandlung

    m_GradientOrientation = New_GradientOrientation
    Call AmpelAnzeigen
    PropertyChanged "GradientOrientation"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property
'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=14,0,0,0
Public Property Get GreenOrientation() As eGreenOrientation
Attribute GreenOrientation.VB_Description = "gibt die Ausrichtung des grnen Lichtsignals zurck oder legt sie fest"
    GreenOrientation = m_GreenOrientation
End Property

Public Property Let GreenOrientation(ByVal New_GreenOrientation As eGreenOrientation)
On Error GoTo Fehlerbehandlung

    m_GreenOrientation = New_GreenOrientation
    Call AmpelAnzeigen
    PropertyChanged "GreenOrientation"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=UserControl,UserControl,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Legt ein benutzerdefiniertes Maussymbol fest."
    Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
On Error GoTo Fehlerbehandlung

    Set UserControl.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=UserControl,UserControl,-1,MousePointer
Public Property Get MousePointer() As eMousePointerConstants
Attribute MousePointer.VB_Description = "Gibt den Typ des Mauszeigers zurck, der angezeigt wird, wenn dieser sich ber einem Teil eines Objekts befindet, oder legt diesen fest."
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As eMousePointerConstants)
On Error GoTo Fehlerbehandlung

    UserControl.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,0
Public Property Get IntervalGreenPhase() As Long
Attribute IntervalGreenPhase.VB_Description = "Gibt die Anzahl der Millisekunden zwischen Aufrufen an das Timer-Ereignis eines Zeitgeber-Steuerelements zurck oder legt diese fest."
    IntervalGreenPhase = m_IntervalGreenPhase
    tmrGreenPhase.Interval() = m_IntervalGreenPhase
End Property

Public Property Let IntervalGreenPhase(ByVal New_IntervalGreenPhase As Long)
On Error GoTo Fehlerbehandlung

If New_IntervalGreenPhase < 0 Then
    Exit Property
Else
    m_IntervalGreenPhase = New_IntervalGreenPhase
    tmrGreenPhase.Interval() = New_IntervalGreenPhase
    PropertyChanged "IntervalGreenPhase"
End If

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,
Public Property Get IntervalYellowPhase() As Long
Attribute IntervalYellowPhase.VB_Description = "Gibt die Anzahl der Millisekunden zwischen Aufrufen an das Timer-Ereignis eines Zeitgeber-Steuerelements zurck oder legt diese fest."
    IntervalYellowPhase = m_IntervalYellowPhase
    tmrYellowPhase.Interval() = m_IntervalYellowPhase
End Property

Public Property Let IntervalYellowPhase(ByVal New_IntervalYellowPhase As Long)
On Error GoTo Fehlerbehandlung

If New_IntervalYellowPhase < 0 Then
    Exit Property
Else
    m_IntervalYellowPhase = New_IntervalYellowPhase
    tmrYellowPhase.Interval() = New_IntervalYellowPhase
    PropertyChanged "IntervalYellowPhase"
End If

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,
Public Property Get IntervalRedPhase() As Long
Attribute IntervalRedPhase.VB_Description = "Gibt die Anzahl der Millisekunden zwischen Aufrufen an das Timer-Ereignis eines Zeitgeber-Steuerelements zurck oder legt diese fest."
    IntervalRedPhase = m_IntervalRedPhase
    tmrRedPhase.Interval() = m_IntervalRedPhase
End Property

Public Property Let IntervalRedPhase(ByVal New_IntervalRedPhase As Long)
On Error GoTo Fehlerbehandlung

If New_IntervalRedPhase < 0 Then
    Exit Property
Else
    m_IntervalRedPhase = New_IntervalRedPhase
    tmrRedPhase.Interval() = New_IntervalRedPhase
    PropertyChanged "IntervalRedPhase"
End If

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,
Public Property Get IntervalRedYellowPhase() As Long
Attribute IntervalRedYellowPhase.VB_Description = "Gibt die Anzahl der Millisekunden zwischen Aufrufen an das Timer-Ereignis eines Zeitgeber-Steuerelements zurck oder legt diese fest."
    IntervalRedYellowPhase = m_IntervalRedYellowPhase
    tmrRedYellowPhase.Interval() = m_IntervalRedYellowPhase
End Property

Public Property Let IntervalRedYellowPhase(ByVal New_IntervalRedYellowPhase As Long)
On Error GoTo Fehlerbehandlung

If New_IntervalRedYellowPhase < 0 Then
    Exit Property
Else
    m_IntervalRedYellowPhase = New_IntervalRedYellowPhase
    tmrRedYellowPhase.Interval() = New_IntervalRedYellowPhase
    PropertyChanged "IntervalRedYellowPhase"
End If

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,False
Public Property Get ShowArrows() As Boolean
Attribute ShowArrows.VB_Description = "gibt die Anzeige der Richtungspfeile zurck oder legt sie fest"
    ShowArrows = m_ShowArrows
End Property

Public Property Let ShowArrows(ByVal New_ShowArrows As Boolean)
    m_ShowArrows = New_ShowArrows
    Call AmpelAnzeigen
    PropertyChanged "ShowArrows"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=14,0,0,0
Public Property Get OrientationArrowhead() As eOrientationArrowhead
Attribute OrientationArrowhead.VB_Description = "gibt die Orientierung der Richtungspfeile zurck oder legt sie fest"
    OrientationArrowhead = m_OrientationArrowhead
End Property

Public Property Let OrientationArrowhead(ByVal New_OrientationArrowhead As eOrientationArrowhead)
On Error GoTo Fehlerbehandlung

    m_OrientationArrowhead = New_OrientationArrowhead
    PropertyChanged "OrientationArrowhead"

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,True
Public Property Get ShowFocusRect() As Boolean
Attribute ShowFocusRect.VB_Description = "legt fest ob ein FocusRect angezeigt werden soll"
    ShowFocusRect = m_ShowFocusRect
End Property

Public Property Let ShowFocusRect(ByVal New_ShowFocusRect As Boolean)
    m_ShowFocusRect = New_ShowFocusRect
    PropertyChanged "ShowFocusRect"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=7,0,0,1
Public Property Get DrawWidth() As Integer
Attribute DrawWidth.VB_Description = "Gibt die Linienbreite fr die Ausgabe von Grafikmethoden zurck oder legt diese fest."
    DrawWidth = m_DrawWidth
End Property

Public Property Let DrawWidth(ByVal New_DrawWidth As Integer)
On Error GoTo Fehlerbehandlung

If New_DrawWidth < 1 Then
    Exit Property
Else
    m_DrawWidth = New_DrawWidth
    Call AmpelAnzeigen
    PropertyChanged "DrawWidth"
End If

Exit Property
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, Ambient.DisplayName
End Property

